Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Manipulator/UniformSomePositionsManipulator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Manipulator/UniformSomePositionsManipulator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Manipulator/UniformSomePositionsManipulator.cs	(revision 9089)
@@ -0,0 +1,69 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.CombinedIntegerVectorEncoding.Manipulator {
+  public class UniformSomePositionsManipulator : CombinedIntegerVectorManipulator {
+
+    public IValueLookupParameter<PercentValue> ProbabilityParameter {
+      get { return (IValueLookupParameter<PercentValue>)Parameters["Probability"]; }
+    }
+    public ILookupParameter<IItemSet<CombinedIntegerVector>> PossibleActionsParameter {
+      get { return (ILookupParameter<IItemSet<CombinedIntegerVector>>)Parameters["PossibleActions"]; }
+    }
+
+    [StorableConstructor]
+    protected UniformSomePositionsManipulator(bool deserializing) : base(deserializing) { }
+    protected UniformSomePositionsManipulator(UniformSomePositionsManipulator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new UniformSomePositionsManipulator(this, cloner);
+    }
+    public UniformSomePositionsManipulator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<PercentValue>("Probability", "The probability for each dimension to be manipulated.", new PercentValue(0.5)));
+      Parameters.Add(new LookupParameter<IItemSet<CombinedIntegerVector>>("PossibleActions"));
+    }
+
+    protected override CombinedIntegerVector Manipulate(IRandom random, CombinedIntegerVector parent, CombinedIntegerVector child) {
+      return Manipulate(random, parent, child, ProbabilityParameter.ActualValue.Value, PossibleActionsParameter.ActualValue);
+    }
+
+    public static CombinedIntegerVector Manipulate(IRandom random, CombinedIntegerVector parent, CombinedIntegerVector child, double probability, IItemSet<CombinedIntegerVector> possibleActions) {
+      for (int index = 0; index < child.Length - child.ActionLength; index++) {
+        if (random.NextDouble() < probability) {
+          UniformOnePositionInConditionManipulator.Manipulate(parent, child, index);
+        }
+      }
+
+      if (child.ActionLength > 0 && random.NextDouble() < probability) {
+        UniformActionManipulator.Manipulate(random, parent, child, possibleActions);
+      }
+      return child;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs	(revision 9089)
@@ -0,0 +1,79 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("ActionSelector", "")]
+  [StorableClass]
+  public class ActionSelector : SingleSuccessorOperator, IStochasticOperator {
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IClassifier> SelectedActionParameter {
+      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    }
+    public ILookupParameter<IItemDictionary<IClassifier, DoubleValue>> PredictionArrayParameter {
+      get { return (ILookupParameter<IItemDictionary<IClassifier, DoubleValue>>)Parameters["PredictionArray"]; }
+    }
+    public ILookupParameter<PercentValue> ExplorationProbabilityParameter {
+      get { return (ILookupParameter<PercentValue>)Parameters["ExplorationProbability"]; }
+    }
+
+    [StorableConstructor]
+    protected ActionSelector(bool deserializing) : base(deserializing) { }
+    protected ActionSelector(ActionSelector original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ActionSelector()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction", "Action, which has been selected."));
+      Parameters.Add(new LookupParameter<IItemDictionary<IClassifier, DoubleValue>>("PredictionArray"));
+      Parameters.Add(new LookupParameter<PercentValue>("ExplorationProbability"));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ActionSelector(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (RandomParameter.ActualValue.NextDouble() > ExplorationProbabilityParameter.ActualValue.Value) {
+        double maxValue = PredictionArrayParameter.ActualValue.Max(x => x.Value.Value);
+        SelectedActionParameter.ActualValue = PredictionArrayParameter.ActualValue.Where(x => x.Value.Value.IsAlmost(maxValue))
+                                                                                  .Select(x => x.Key)
+                                                                                  .First();
+      } else {
+        int actionIndex = RandomParameter.ActualValue.Next(0, PredictionArrayParameter.ActualValue.Count);
+        SelectedActionParameter.ActualValue = PredictionArrayParameter.ActualValue.ElementAt(actionIndex).Key;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs	(revision 9089)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("MaxValueActionSelector", "")]
+  [StorableClass]
+  public class MaxValueActionSelector : OldActionSelector {
+
+    public ILookupParameter<ItemArray<DoubleValue>> ValueParameter {
+      get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["ValueParameter"]; }
+    }
+
+    [StorableConstructor]
+    protected MaxValueActionSelector(bool deserializing) : base(deserializing) { }
+    protected MaxValueActionSelector(MaxValueActionSelector original, Cloner cloner) : base(original, cloner) { }
+    public MaxValueActionSelector()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("ValueParameter", "DoubleValue which will be summed up."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MaxValueActionSelector(this, cloner);
+    }
+
+    protected override IClassifier SelectAction(List<IScope> scopes) {
+      Dictionary<IClassifier, double> actionSet = new Dictionary<IClassifier, double>();
+      for (int i = 0; i < MatchParameter.ActualValue.Length; i++) {
+        var action = MatchParameter.ActualValue[i].Action;
+        if (actionSet.ContainsKey(action)) {
+          actionSet[action] += ValueParameter.ActualValue[i].Value;
+        } else {
+          actionSet[action] = ValueParameter.ActualValue[i].Value;
+        }
+      }
+      return actionSet.OrderByDescending(x => x.Value).First().Key;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs	(revision 9089)
@@ -0,0 +1,67 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("OldActionSelector", "A base class for action selection operators.")]
+  [StorableClass]
+  public abstract class OldActionSelector : SingleSuccessorOperator {
+
+    protected ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public ILookupParameter<ItemArray<IClassifier>> MatchParameter {
+      get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["MatchParameter"]; }
+    }
+    public IValueLookupParameter<IClassifier> SelectedActionParameter {
+      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    }
+
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+
+    [StorableConstructor]
+    protected OldActionSelector(bool deserializing) : base(deserializing) { }
+    protected OldActionSelector(OldActionSelector original, Cloner cloner) : base(original, cloner) { }
+
+    protected OldActionSelector()
+      : base() {
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
+      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction", "Action, which has been selected."));
+    }
+
+    public sealed override IOperation Apply() {
+      List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
+      SelectedActionParameter.ActualValue = SelectAction(scopes);
+      return base.Apply();
+    }
+
+    protected abstract IClassifier SelectAction(List<IScope> scopes);
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs	(revision 9089)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("RandomActionSelector", "A random action selector.")]
+  [StorableClass]
+  public class RandomActionSelector : OldActionSelector {
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    [StorableConstructor]
+    protected RandomActionSelector(bool deserializing) : base(deserializing) { }
+    protected RandomActionSelector(RandomActionSelector original, Cloner cloner) : base(original, cloner) { }
+    public RandomActionSelector()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator used for stochastic selection."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RandomActionSelector(this, cloner);
+    }
+
+    protected override IClassifier SelectAction(List<IScope> scopes) {
+      IRandom random = RandomParameter.ActualValue;
+      int index = random.Next(MatchParameter.ActualValue.Length);
+      return MatchParameter.ActualValue[index].Action;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs	(revision 9089)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("CoveringOperator", "")]
+  [StorableClass]
+  public class CoveringOperator : SingleSuccessorOperator, ICovering {
+
+    #region Parameter Properties
+    public ILookupParameter<IClassifier> CoverClassifierParameter {
+      get { return (ILookupParameter<IClassifier>)Parameters["CoverClassifier"]; }
+    }
+    public ILookupParameter<IItemSet<IClassifier>> ActionsInMatchSetParameter {
+      get { return (ILookupParameter<IItemSet<IClassifier>>)Parameters["ActionsInMatchSet"]; }
+    }
+    public ILookupParameter<IItemSet<IClassifier>> PossibleActionsParameter {
+      get { return (ILookupParameter<IItemSet<IClassifier>>)Parameters["PossibleActions"]; }
+    }
+    public ILookupParameter<IntValue> MinimalNumberOfUniqueActionsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["MinimalNumberOfUniqueActions"]; }
+    }
+    public IValueLookupParameter<IOperator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters[" Evaluator"]; }
+    }
+    public IValueLookupParameter<ICoveringSolutionCreator> SolutionCreatorParameter {
+      get { return (IValueLookupParameter<ICoveringSolutionCreator>)Parameters["SolutionCreator"]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<BoolValue> ParallelParameter {
+      get { return (IValueLookupParameter<BoolValue>)Parameters["Parallel"]; }
+    }
+    private ScopeParameter CurrentScopeParameter {
+      get { return (ScopeParameter)Parameters["CurrentScope"]; }
+    }
+    public IScope CurrentScope {
+      get { return CurrentScopeParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected CoveringOperator(bool deserializing) : base(deserializing) { }
+    protected CoveringOperator(CoveringOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CoveringOperator(this, cloner);
+    }
+    public CoveringOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<IClassifier>("CoverClassifier"));
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("ActionsInMatchSet"));
+      Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("PossibleActions"));
+      Parameters.Add(new LookupParameter<IntValue>("MinimalNumberOfUniqueActions"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator"));
+      Parameters.Add(new ValueLookupParameter<ICoveringSolutionCreator>("SolutionCreator"));
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Parallel", "True if the operator should be applied in parallel on all sub-scopes, otherwise false.", new BoolValue(true)));
+      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope to which the new solutions are added as sub-scopes."));
+    }
+
+    public override IOperation Apply() {
+      int count = MinimalNumberOfUniqueActionsParameter.ActualValue.Value - ActionsInMatchSetParameter.ActualValue.Count;
+      ICoveringSolutionCreator creator = SolutionCreatorParameter.ActualValue;
+      IOperator evaluator = EvaluatorParameter.ActualValue;
+      bool parallel = ParallelParameter.ActualValue.Value;
+
+      IItemSet<IClassifier> clone = (IItemSet<IClassifier>)PossibleActionsParameter.ActualValue.Clone();
+      clone.ExceptWith(ActionsInMatchSetParameter.ActualValue);
+
+      if (count > clone.Count) {
+        throw new ArgumentException("More classifiers with unique actions shall be created than unique actions are available.");
+      }
+
+      int current = CurrentScope.SubScopes.Count;
+      for (int i = 0; i < count; i++) {
+        CurrentScope.SubScopes.Add(new Scope((current + i).ToString()));
+      }
+
+      creator.ActionParameter.ActualName = "Action";
+      OperationCollection variableCreation = new OperationCollection() { Parallel = parallel };
+      OperationCollection creation = new OperationCollection();
+      OperationCollection evaluation = new OperationCollection() { Parallel = parallel };
+      for (int i = 0; i < count; i++) {
+        VariableCreator variableCreator = new VariableCreator();
+        int pos = RandomParameter.ActualValue.Next(clone.Count);
+        IClassifier action = clone.ElementAt(pos);
+        clone.Remove(action);
+        variableCreator.CollectedValues.Add(new ValueParameter<IClassifier>("Action", action));
+        variableCreation.Add(ExecutionContext.CreateOperation(variableCreator, CurrentScope.SubScopes[current + i]));
+        creation.Add(ExecutionContext.CreateOperation(creator, CurrentScope.SubScopes[current + i]));
+        evaluation.Add(ExecutionContext.CreateOperation(evaluator, CurrentScope.SubScopes[current + i]));
+      }
+      OperationCollection next = new OperationCollection();
+      next.Add(variableCreation);
+      next.Add(creation);
+      next.Add(evaluation);
+      next.Add(base.Apply());
+      return next;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs	(revision 9089)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface ICovering : IStochasticOperator {
+    ILookupParameter<IClassifier> CoverClassifierParameter { get; }
+    ILookupParameter<IItemSet<IClassifier>> ActionsInMatchSetParameter { get; }
+    ILookupParameter<IItemSet<IClassifier>> PossibleActionsParameter { get; }
+
+    ILookupParameter<IntValue> MinimalNumberOfUniqueActionsParameter { get; }
+    IValueLookupParameter<IOperator> EvaluatorParameter { get; }
+    IValueLookupParameter<ICoveringSolutionCreator> SolutionCreatorParameter { get; }
+    IValueLookupParameter<BoolValue> ParallelParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs	(revision 9089)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface ICoveringSolutionCreator : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
+    ILookupParameter<IClassifier> CoverClassifierParameter { get; }
+    ILookupParameter<IClassifier> ActionParameter { get; }
+
+    IValueLookupParameter<IClassifier> CreatedClassifierParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IConditionActionEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IConditionActionEvaluator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IConditionActionEvaluator.cs	(revision 9089)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IClassifierFitnessEvaluator : IEvaluator {
+    IValueLookupParameter<DoubleValue> FitnessParameter { get; }
+    IValueLookupParameter<DoubleValue> CurrentPayoffParameter { get; }
+  }
+}
